/*
# ==================================================================================
# Copyright (c) 2020 HCL Technologies Limited.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ==================================================================================
*/
#ifndef XAPP_MODEL_XAppConfig_H
#define XAPP_MODEL_XAppConfig_H
#include"ConfigMetadata.h"

namespace xapp {
	namespace model {
		struct  XAppConfig : public ModelBase {
			ConfigMetadata m_ConfigMetadata;
			nlohmann::json config;// = nlohmann::json::object();
			nlohmann::json validator_schema = R"(
				{
				"$schema": "http://json-schema.org/draft-07/schema#",
				"title": "XAppConfig",
				"properties": {
				    
				    "metadata": {
				        "type": "object"
				    },
					 "config": {
				        "type": "object"
				    }
				},
				"required": [
				             "metadata",
							 "config"
				             ],
				"type": "object"
				})"_json;
			virtual nlohmann::json get_validator_schema() const { return validator_schema; }
		};
		void from_json(const nlohmann::json& j, XAppConfig& ref);
		void from_json(const nlohmann::json& j, std::vector<XAppConfig>& ref);
		void to_json(nlohmann::json& j, const XAppConfig& ref);
		void to_json(nlohmann::json& j, const std::vector<XAppConfig>& ref);

	}
}
#endif
